      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      PARAMETER ( MAXC = 1200 )
C
      DIMENSION   GDW(8784)
      DIMENSION   FACT(25),  PHASE(25)
      REAL        SLIMIT
      REAL        DOOD, AMPL, AMPL2
      INTEGER     P4FLAG
C
      COMMON /TABLE4/ DOOD(8,MAXC), AMPL(MAXC), AMPL2(MAXC), IORD(MAXC)
C
C     TABLE OF TIDAL FACTOR AND PHASE
C       M0+S0,   LONG PERIOD,
C          Q1,       O1,       M1,   { ( PI1,      P1,)      S1,
C        ( K1,       PSI1,     PHI1,) }  J1,       OO1,
C          2N2,      N2,     ( ALPHA2,   M2,       BETA2,)
C        ( LAMBDA2,  L2,)  { ( T2,       S2,)      K2,}
C          M3,       M4
C
C     AMPLITUDE FACTOR
      DATA  FACT
     *  / 1.0000D0, 1.1550D0,
     *    1.1582D0, 1.1580D0, 1.1574D0, 1.1544D0, 1.1529D0, 1.1497D0,
     *    1.1386D0, 1.2329D0, 1.1718D0, 1.1599D0, 1.1592D0,
     *    1.1600D0, 1.1600D0, 1.1600D0, 1.1600D0, 1.1600D0,
     *    1.1600D0, 1.1600D0, 1.1600D0, 1.1600D0, 1.1600D0,
     *    1.0700D0, 1.0365D0  /
C
C     PHASE (LOCAL, LAG:NEGATIVE, DEGREE)
      DATA  PHASE
     *  / 0.00D0,   0.00D0,
     *    0.00D0,   0.00D0,   0.00D0,   0.00D0,   0.00D0,   0.01D0,
     *    0.06D0,   0.78D0,   0.03D0,   0.00D0,   0.00D0,
     *    0.00D0,   0.00D0,   0.00D0,   0.00D0,   0.00D0,
     *    0.00D0,   0.00D0,   0.00D0,   0.00D0,   0.00D0,
     *    0.00D0,   0.00D0    /
C
C    LOCATION
C
      AEAST  =  141.335D0
      ANORTH =   39.148D0
      HI     =  393.0D0
      IYEAR  = 1996
      IMONTH =    1
      IDAY   =    1
      IHOUR  =    0
      IMIN   =    0
      NUM    =  744
      STEP   =    1.0D0
      ETMUT  =   60.0D0
      TIMSYS =    0.0D0
C
      KIND   =    1
      AZ     =    0.D0
C
      GRAV   = 982.024D0
      LOVENM =    2
      P4FLAG =    1
C
      SLIMIT = 0.000000
C
C     THORETICAL TIDE CALCULATION
C
      CALL TIDE4N( GDW, NUM, STEP,
     *             IYEAR, IMONTH, IDAY, IHOUR, IMIN,
     *             AEAST, ANORTH, HI, ETMUT, TIMSYS,
     *             GRAV, KIND, AZ, LOVENM,
     *             P4FLAG, SLIMIT, FACT, PHASE      )
C
      WRITE(6,150) (-GDW(I),I=1,NUM)
  150 FORMAT(6F10.2)
C
      STOP
      END
*PROCESS IAP(DIAG)
      SUBROUTINE TIDE4N( XT, NUMB, STEP,
     *                   JA, JB, JC, JD, JE,
     *                   RM, PH, HI, ETMUT, TIMSYS,
     *                   GRAV, KIND, AZ, LOVENM,
     *                   P4FLAG, SLIMIT, FCT, PHDIF )
C
C     THEORETICAL TIDE CALCULATION WITH TAMURA'S TABLE
C
C     CODED BY Y.TAMURA    ( JULY 01, 1991 )
C       NATIONAL ASTRONOMICAL OBSERVATORY, MIZUSAWA
C       2-12 HOSHIGAOKA MIZUSAWA IWATE 023  JAPAN
C       TEL. (81)-197-227131   FAX (81)-197-223410
C       E-mail tamura@miz.nao.ac.jp
C
C     OUTPUT DATA
C       XT(I)   : KIND = 1     GRAVITY TIDE ( UNIT IN MICRO GALS )
C               : KIND = 2,3   TILT         ( UNIT IN MILLI SECOND )
C               : KIND = 4,5,6 STRAIN       ( UNIT IN NANO STRAIN )
C               : KIND = 7     POTENTIAL/GRAV/6371023.6D2*1.D9
C               : KIND = 8     OCEAN TIDE   ( UNIT IN CM )
C       AZ      : 90.0 IF KIND=3,5;  45.0 IF KIND=6
C
C     INPUT DATA
C       NUMB    : NUMBER OF CALCULATIONS
C       STEP    : TIME INTERVAL IN HOURS
C       JA      : ORIGIN TIME  YEAR ( 1901 =< JA =< 2099 )
C       JB      :     "        MONTH
C       JC      :     "        DAY
C       JD      :     "        HOUR
C       JE      :     "        MINUTE
C       RM      : STATION PLACE   EAST LONGITUDE IN DEGREES
C       PH      :     "           NORTH LATITUDE     "
C       HI      :     "           HEIGHT         IN METERS
C       ETMUT   : TD(ET) - UT  IN SECONDS
C       TIMSYS  : TIME CORRECTON ( JST: TIMSYS=-9.D0, UT: TIMSYS=0.D0 )
C       GRAV    : GRAVITY IN GAL ( USE 982.024D0 IF IT IS UNKNOWN )
C       KIND    : KIND OF TIDE
C       AZ      : AZIMUTH OF TILT AND STRAIN OBSERVATION
C               : KIND = 1   DOWNWARD ATTRACTION OF GRAVITY TIDE
C               : KIND = 2   TILT      AZ : FROM NORTH, CLOCKWISE
C               : KIND = 4   STRAIN    AZ : FROM NORTH, CLOCKWISE
C               : KIND = 7   POTENTIAL/GRAV/RADIUS(6371023.6D2)*1.D9
C               : KIND = 8   POTENTIAL/GRAV
C               :
C               : KIND = 3 IS EQUAL TO THE COMBINATION OF KIND=2, AZ=90.
C               : KIND = 5             "                  KIND=4, AZ=90.
C               : KIND = 6             "                  KIND=4, AZ=45.
C               : AZ IS NOT USED WHEN KIND=1,7,8
C               : SAMPLE
C               :   GRAVITY TIDE : KIND = 1
C               :   NS TILT      : KIND = 2,    (KIND=2, AZ= 0.0)
C               :   EW TILT      : KIND = 3,    (KIND=2, AZ=90.0)
C               :   NS STRAIN    : KIND = 4,    (KIND=4, AZ= 0.0)
C               :   EW STRAIN    : KIND = 5,    (KIND=4, AZ=90.0)
C               :   NE STRAIN    : KIND = 6,    (KIND=4, AZ=45.0)
C               :   STRAIN, ETC  : KIND = 7,
C               :   OCEAN TIDE   : KIND = 8
C       LOVENM  : FLAG VALID FOR KIND = 1, 2, 3, 7 & 8
C               : IF LOVENM=0, LOVE NUMBER H, K & L ARE NOT USED
C               : IF LOVENM=1, LOVE NUMBER H, K & L ARE USED
C               : LOVE NUMBER H & L ARE ALWAYS USED WHEN KIND=4,5,6
C               : IF LOVENM=2,
C               :   DIURNAL TIDE      : RATIO OF P3:P2,P4:P2 ARE ASSUMED
C               :   SEMI-DIURNAL TIDE : RATIO OF P3:P2,P4:P2      "
C               :   TER-DIIURNAL TIDE : RATIO OF P4:P3            "
C       P4FLAG  : 0 : THE 4TH ORDER POTENTIAL WILL NOT BE CONTAINED
C               : 1 : THE 4TH ORDER POTENTIAL WILL BE CONTAINED
C       SLIMIT  : LOWER AMPLITUDE LIMIT TO BE CONTAINED, NORMALLY 0.0
C       FCT     : OBSERVED AMPLITUDE FACTORS
C       PHDIF   : OBSERVED PHASE DIFFERENCES (LAG:NEGATIVE, IN DEGREES)
C
C     REFERENCES
C       TAMURA, Y. 1982, A COMPUTER PROGRAM FOR THE TIDE-GENERATING
C         FORCE, PUBLI. INT. LATIT. OBS. MIZUSAWA, 16, PP1-20.
C       TAMURA, Y. 1987, A HARMONIC DEVELOPMENT OF THE TIDE-GENERATING
C         POTENTIAL, MAREES TERRESTRES BULLETIN D'INFORMATIONS, 99,
C         PP6813-6855.
C       TAMURA, Y., SATO, T., OOE, M. AND ISHIGURO, M. (1991)
C         A PROCEDURE FOR TIDAL ANALYSIS WITH A BAYESIAN INFORMATION
C         CRITERION, GEOPHYSICAL JOURNAL INTERNATIONAL, 104, PP507-516.
C       TSUKAMOTO, H. 1980, CHIKYU CHOSEKI NI KANSURU OBOEGAKI, SONO 1,
C         PRIVATE COMUNICATION. (IN JAPANESE)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      PARAMETER ( MAXC = 1200 )
C
      DIMENSION  XT(*)
C
      DIMENSION  FACTX(MAXC), AMPLX(MAXC)
      DIMENSION  DIFFX(MAXC), CONST(MAXC), PHASEI(MAXC)
      DIMENSION  FCT(25), PHDIF(25)
      DIMENSION  ZZ(2:4,0:4), PHCORR(2:4,0:4)
      INTEGER    KUGIRI(25), P4FLAG
C
      REAL    SLIMIT
      REAL    DOOD, AMPL, AMPL2
      COMMON /TABLE4/ DOOD(8,MAXC), AMPL(MAXC), AMPL2(MAXC), IORD(MAXC)
C
      DATA  PI    / 3.14159 26535 89793 D0/
      DATA  RE    / 6378137.D2 /
      DATA  FLAT  / 3.35292D-3 /
      DATA  GE    / 3.98600448D20 /
      DATA  FMU   / 0.012300034D0 /
      DATA  SINPI / 3422.448D0 /
C
      DATA  ININTV / 500 /
      DATA  NCALLD /   0 /
      DATA  KUGIRI
     *     /    2, 281,
     *        424, 482, 530, 537, 547, 551, 569, 573, 586,  626, 731,
     *        830, 880, 893, 912, 936, 944, 962, 982, 991, 1108,
     *       1190, 1200  /
C
C
      ILL = 0
      IF( NUMB.LE.0 )                       ILL = 1
      IF( JA.LE.1900 .OR. JA.GE.2100 )      ILL = 1
      IF( JB.LE.0 .OR. JB.GE.13 )           ILL = 1
      IF( JC.LE.0 .OR. JC.GE.32 )           ILL = 1
      IF( JD.LT.0 .OR. JD.GE.24 )           ILL = 1
      IF( JE.LT.0 .OR. JE.GE.60 )           ILL = 1
      IF( DABS(RM).GT.360.D0 )              ILL = 1
      IF( DABS(PH).GT. 90.D0 )              ILL = 1
      IF( DABS(HI).GT.9999.D0 )             ILL = 1
      IF(ETMUT.LT.0.D0 .OR. ETMUT.GT.99.D0) ILL = 1
      IF( DABS(TIMSYS).GT.24.D0 )           ILL = 1
      IF( KIND.LT.1 .OR.  KIND.GT.8 )       ILL = 1
      IF( KIND.GE.4 .AND. KIND.LE.6 )    LOVENM = 1
      IF( DABS(AZ).GT.360.D0 )              ILL = 1
      IF( GRAV.LT.0.D0 .OR. GRAV.GT.1.D3 )  ILL = 1
      IF( LOVENM.LT.0 .OR. LOVENM.GT.2 )    ILL = 1
      IF( P4FLAG.LT.0 .OR. P4FLAG.GT.1 )    ILL = 1
      IF( SLIMIT.GE.0.910000 )              ILL = 1
      IF( ILL .NE. 0 )  THEN
         WRITE(6,10)
         WRITE(6,12)  NUMB, JA, JB, JC, JD, JE
         WRITE(6,14)  RM, PH, HI, ETMUT, TIMSYS, KIND
         WRITE(6,16)  AZ, GRAV, LOVENM, P4FLAG, SLIMIT
         STOP
      END IF
   10 FORMAT(/' INVARID PARAMETERS      STOPPED IN TIDE4N')
   12 FORMAT( ' NUMB, JA, JB, JC, ID, IE =',6I10)
   14 FORMAT( ' RM, PH, HI, ETMUT, TIMSYS, KIND =',3F10.3,2F10.1,I10)
   16 FORMAT( ' AZ, GRAV, LOVENM, P4FLAG, SLIMIT =',2F10.3,2I8,F10.6)
C
C
      RAD = PI/180.D0
C
C
      IF( NCALLD.EQ.0 )  THEN
         CALL TREAD4
         NCALLD = 1
      END IF
C
C
      CV = 3.D0 / 4.D0 * FMU * GE * ( SINPI/3600.D0*RAD )**3 / RE**2
      PHI  = PH * RAD
      ALTI = HI * 100.D0
C
      CALL SETZZZ( PHI, ALTI, GRAV, RE, FLAT, CV,
     *             KIND, AZ, LOVENM, ZZ, PHCORR  )
C
C
      KK = 1
      DO 40 I = 1, MAXC
C
         KO = IORD(I)
         KS = INT( DOOD(1,I) )
         IF( MOD(KO+KS,2).EQ.0 )  THEN
            PHASEI(I) =  0.D0
         ELSE
            PHASEI(I) = -PI/2.D0
         END IF
C
         FACTX(I)  = 0.D0
         PHASEI(I) = PHASEI(I) + ( PHCORR(KO,KS) + PHDIF(KK) )*RAD
C
         IF( I.EQ.KUGIRI(KK) )  KK = KK + 1
C
   40 CONTINUE
C
C
      TU0 = ( TJULID( JA, JB, JC, JD, JE ) - 2451545.D0 + TIMSYS/24.D0 )
     *         / 36525.D0
      TD0 = TU0 + ETMUT/86400.D0/36525.D0
      DELT = STEP / 24.D0 / 36525.D0
      UT0  = DBLE( JD ) + DBLE( JE )/60.D0 + TIMSYS
C
C
      DO 2000 K = 1, NUMB
C
         AMPX = 0.D0
C
         IF( MOD(K,ININTV) .EQ. 1 )  THEN
C
C           INITIALIZATION
C
            TU   = TU0 + DELT*DBLE(K-1)
            TU2  = TU*TU
            TD   = TD0 + DELT*DBLE(K-1)
            TD2  = TD*TD
            UT   = UT0 + STEP*DBLE(K-1)
            TMID = TD0 + DELT*DBLE(K+ININTV/2)
C
            KK = 1
            DO 60 I = 1, MAXC
               KO = IORD(I)
               IF( P4FLAG.EQ.0 .AND. KO.EQ.4 )  GO TO 50
               IF( ABS(AMPL(I)) .LE. SLIMIT  )  GO TO 50
               KS = INT( DOOD(1,I) )
C
               FACTX(I) = (AMPL(I) + AMPL2(I)*TMID) * ZZ(KO,KS)
               FACTX(I) = FACTX(I) * FCT(KK)
C
   50          IF( I.EQ.KUGIRI(KK) )  KK = KK + 1
   60       CONTINUE
C
            EL1 = 280.4606184D0 + 36000.7700536D0*TU
     *                              + 0.00038793D0*TU2
     *                              - 0.0000000258D0*TU**3
            EL2 = 218.316656D0 + 481267.881342D0*TD - 0.001330D0 *TD2
     *            + 0.0040D0*DCOS( ( 29.D0+133.D0*TMID)*RAD )
            EL1 =  15.D0*UT + RM + EL1 - EL2
            EL3 = 280.466449D0  + 36000.769822D0*TD + 0.0003036D0*TD2
     *            + 0.0018D0*DCOS( (159.D0+ 19.D0*TMID)*RAD )
            EL4 =  83.353243D0   + 4069.013711D0*TD - 0.010324D0 *TD2
            EL5 = 234.955444D0   + 1934.136185D0*TD - 0.002076D0 *TD2
            EL6 = 282.937348D0      + 1.719533D0*TD + 0.0004597D0*TD2
            EL7 = 248.1D0       + 32964.47D0    *TD
            EL8 =  81.5D0       + 22518.44D0    *TD
C
            EL1D =  36000.7700536D0 + 0.00038793D0*2.D0*TU
     *                              - 0.0000000258D0*3.D0*TU2
            EL2D = 481267.881342D0  - 0.001330D0 *2.D0*TD
     *         - 0.0040D0*DSIN( ( 29.D0+133.D0*TMID)*RAD )*133.D0*RAD
            EL1D =  15.D0*STEP/DELT + EL1D - EL2D
            EL3D =  36000.769822D0  + 0.0003036D0*2.D0*TD
     *         - 0.0018D0*DSIN( (159.D0+ 19.D0*TMID)*RAD )* 19.D0*RAD
            EL4D =   4069.013711D0  - 0.010324D0 *2.D0*TD
            EL5D =   1934.136185D0  - 0.002076D0 *2.D0*TD
            EL6D =      1.719533D0  + 0.0004597D0*2.D0*TD
            EL7D =  32964.47D0
            EL8D =  22518.44D0
C
            RADEL2 = RAD*DELT*0.5D0
*VOPTION NOVEC
            DO 1300 I = 1, MAXC
               TMX = ( EL1*DOOD(1,I)  + EL2*DOOD(2,I)  + EL3*DOOD(3,I)
     *               + EL4*DOOD(4,I)  + EL5*DOOD(5,I)  + EL6*DOOD(6,I)
     *               + EL7*DOOD(7,I)  + EL8*DOOD(8,I)  ) * RAD
     *               + PHASEI(I)
               TC  = ( EL1D*DOOD(1,I) + EL2D*DOOD(2,I) + EL3D*DOOD(3,I)
     *               + EL4D*DOOD(4,I) + EL5D*DOOD(5,I) + EL6D*DOOD(6,I)
     *               + EL7D*DOOD(7,I) + EL8D*DOOD(8,I) ) * RADEL2
C
               AMPLX(I) = FACTX(I) * DCOS( TMX )
               AMPX = AMPX + AMPLX(I)
               TMP  = 2.D0*DSIN( TC )
               CONST(I) = TMP**2
               DIFFX(I) = FACTX(I) * TMP * DSIN( TC-TMX )
 1300       CONTINUE
C
CC          SIMPLY
CC          DO 1300 I = 1, MAXC
C1300       AMPX = AMPX + FACTX(I) * DCOS( TMX )
C
         ELSE
C
C           RECURRENCE FORMULA   (DO 1400 LOOP IS VECTORIZEBLE)
            DO 1400 I = 1, MAXC
               DIFFX(I) = DIFFX(I) - CONST(I)*AMPLX(I)
               AMPLX(I) = AMPLX(I) + DIFFX(I)
               AMPX     = AMPX + AMPLX(I)
 1400       CONTINUE
C
         END IF
C
         XT(K) = AMPX
C
 2000 CONTINUE
C
      RETURN
C
      END
*PROCESS NOIAP
      SUBROUTINE SETZZZ( PHI, ALTI, GRAV, RE, FLAT, CV,
     *                   KIND, AZ, LOVENM, GC, PHCORR  )
C
C     INPUT
C       PHI    : NORTH LATITUDE IN RADIANS
C       ALTI   : ALTITUDE IN CM
C       GRAV   : GRAVITY IN GAL
C       RE     : EARTH'S EQUATORIAL RADIUS IN CM
C       FLAT   : EARTH'S FLATTENING
C       CV     : A GENERAL CONSTANT FOR TIDAL PHENOMENA
C       KIND   : 1, 2, 3, .., 8
C       AZ     : AZIMUTH IN DEGREE
C       LOVENM : FLAG FOR LOVE'S NUMBER, VALID FOR KIND=1,2,3,7 AND 8
C     OUTPUT
C       AZ     : MODIFIED WHEN KIND = 3, 5 OR 6
C       GC     : AMPLITUDE COEFFICIENT
C       PHCORR : INITIAL PHASE CORRECTION
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      DOUBLE PRECISION  K2, K3, K4
      DOUBLE PRECISION  L2, L3, L4
C
      DIMENSION  GC(2:4,0:4), PHCORR(2:4,0:4)
C
      DATA  PI          / 3.14159 26535 89793 D0/
C
C     LOVE NUMBERS (L4 IS A TEMPORAL VALUE)
C     LATITUDE AND FREQUENCY DEPENDENCE ARE NOT TAKEN INTO ACCOUNT
      DATA  K2, K3, K4  / 0.299D0,  0.093D0,  0.042D0  /
      DATA  H2, H3, H4  / 0.606D0,  0.291D0,  0.178D0  /
CCC   DATA  L2, L3, L4  / 0.0840D0, 0.0149D0, 0.0050D0 /
      DATA  L2, L3, L4  / 0.0840D0, 0.0149D0, 0.0100D0 /
C
C
      RAD = PI/180.D0
      DEG = 180.D0/PI
C
      COSPHI = DCOS( PHI )
      SINPHI = DSIN( PHI )
      EP = ( FLAT + FLAT**2/2.D0 ) * DSIN( 2.D0*PHI )
     *            - FLAT**2/2.D0   * DSIN( 4.D0*PHI )
      E2 = 2.D0*FLAT - FLAT**2
      ROE = (   1.D0      / DSQRT( 1.D0-E2*SINPHI**2 ) + ALTI/RE )
     *      * COSPHI
      ROP = ( ( 1.D0-E2 ) / DSQRT( 1.D0-E2*SINPHI**2 ) + ALTI/RE )
     *      * SINPHI
      ROE2 = ROE**2
      ROP2 = ROP**2
      RR = RE * DSQRT( ROE2 + ROP2 )
C
C
      DO 10 J = 0, 4
      DO 10 I = 2, 4
         GC(I,J)     = 0.D0
         PHCORR(I,J) = 0.D0
   10 CONTINUE
C
C
      IF( KIND.EQ.1 )  THEN
C
C        GRAVITY IN MICRO GAL
         CV6  =  -1.D6*CV
         GC(2,0) = CV6 * ( ROE*COSPHI - 2.D0*ROP*SINPHI )
         GC(2,1) = 2.D0 * CV6 * ( ROP*COSPHI + ROE*SINPHI )
         GC(2,2) = 2.D0 * CV6 * ROE * COSPHI
         GC(3,0) = 3.D0*DSQRT(5.D0)/2.D0 * CV6 * ( 2.D0*ROE*ROP
     *          * COSPHI + (ROE2-2.D0*ROP2)*SINPHI )
         GC(3,1) = 3.D0*DSQRT(15.D0)/16.D0 * CV6 * ( (3.D0*ROE2
     *            -4.D0*ROP2)*COSPHI - 8.D0*ROE*ROP*SINPHI )
         GC(3,2) = 3.D0*DSQRT(3.D0)/2.D0 * CV6 * ROE
     *              * ( 2.D0*ROP*COSPHI + ROE*SINPHI )
         GC(3,3) = 3.D0 * CV6 * ROE2 * COSPHI
         GC(4,0) = 0.5D0 * CV6
     *          * (  3.D0*ROE*( ROE2-4.D0*ROP2 )     *COSPHI
     *             + 4.D0*ROP*( 2.D0*ROP2-3.D0*ROE2 )*SINPHI )
         GC(4,1) = 448.D0 / ( 3.D0+DSQRT(393.D0))
     *             / DSQRT( 390.D0+2.D0*DSQRT(393.D0) ) * CV6
     *          * (  ROP*( 9.D0*ROE2-4.D0*ROP2 )*COSPHI
     *             + 3.D0*ROE*( ROE2-4.D0*ROP2 )*SINPHI )
         GC(4,2) = 28.D0/9.D0 * CV6
     *          * (  ROE*( ROE2-3.D0*ROP2 )*COSPHI
     *             - 3.D0*ROE2*ROP         *SINPHI )
         GC(4,3) = 16.D0*DSQRT(3.D0)/9.D0 * CV6
     *          * ( 3.D0*ROE2*ROP*COSPHI + ROE**3*SINPHI )
         GC(4,4) = 4.D0 * CV6 * ROE**3 * COSPHI
C
         DFACT2 = 1.D0 +           H2 -    1.50D0*K2
         DFACT3 = 1.D0 + 2.D0/3.D0*H3 - 4.D0/3.D0*K3
         DFACT4 = 1.D0 +     0.5D0*H4 -    1.25D0*K4
C
      ELSE IF( KIND.EQ.2 .OR. KIND.EQ.3 )  THEN
C
CCC      HORIZONTAL ACCELERATION IN MICRO GAL
CCC      CV6  =  CV*1.D6
C        TILT IN MILLI SECOND OF ARC
         CV6  =  CV * DEG * 3600.D3 / GRAV
         XX20 = -CV6 * ( 2.D0*ROP*COSPHI + ROE*SINPHI )
         XX21 =  2.D0 * CV6 * ( ROE*COSPHI - ROP*SINPHI )
         XX22 = -2.D0 * CV6 * ROE * SINPHI
         XX30 = 3.D0*DSQRT(5.D0)/2.D0 * CV6 * ( (ROE2
     *           -2.D0*ROP2)*COSPHI - 2.D0*ROE*ROP*SINPHI )
         XX31 =  3.D0*DSQRT(15.D0)/16.D0 * CV6 * ( -8.D0*ROE*ROP
     *          *COSPHI + ( 4.D0*ROP2-3.D0*ROE2 )*SINPHI )
         XX32 =  3.D0*DSQRT(3.D0)/2.D0 * CV6
     *          * ( ROE2*COSPHI - 2.D0*ROE*ROP*SINPHI )
         XX33 = -3.D0 * CV6 * ROE2 * SINPHI
         XX40 = 0.5D0 * CV6
     *          * (  4.D0*ROP*( 2.D0*ROP2-3.D0*ROE2 )*COSPHI
     *             + 3.D0*ROE*( 4.D0*ROP2-ROE2 )     *SINPHI )
         XX41 = 448.D0 / ( 3.D0+DSQRT(393.D0))
     *             / DSQRT( 390.D0+2.D0*DSQRT(393.D0) ) * CV6
     *          * (  3.D0*ROE*( ROE2-4.D0*ROP2 )*COSPHI
     *            + ROP*( 4.D0*ROP2-9.D0*ROE2 )*SINPHI )
         XX42 = 28.D0/9.D0 * CV6
     *          * ( -3.D0*ROE2*ROP       *COSPHI
     *             + ROE*(3.D0*ROP2-ROE2)*SINPHI )
         XX43 = 16.D0*DSQRT(3.D0)/9.D0 * CV6
     *          * ( ROE**3*COSPHI - 3.D0*ROE2*ROP*SINPHI )
         XX44 = -4.D0 * CV6 * ROE**3 * SINPHI
C
         YY20 = 0.D0
         YY21 = 2.D0 * CV6 * ROP
         YY22 = 2.D0 * CV6 * ROE
         YY30 = 0.D0
         YY31 = 3.D0*DSQRT(15.D0)/16.D0 * CV6
     *          * ( ROE2 - 4.D0*ROP2 )
         YY32 = 3.D0*DSQRT(3.D0) * CV6 * ROE * ROP
         YY33 = 3.D0 * CV6 * ROE2
         YY40 = 0.D0
         YY41 = 448.D0 / ( 3.D0+DSQRT(393.D0) )
     *          / DSQRT( 390.D0+2.D0*DSQRT(393.D0) ) * CV6
     *          * ROP*(3.D0*ROE2-4.D0*ROP2)
         YY42 = 14.D0/9.D0 * CV6
     *          * ROE*(ROE2-6.D0*ROP2)
         YY43 = 16.D0*DSQRT(3.D0)/3.D0 * CV6 * ROE2 * ROP
         YY44 = 4.D0 * CV6 * ROE**3
C
         IF( KIND.EQ.3 )  AZ = 90.D0
         COSAZ = DCOS( AZ*RAD )
         SINAZ = DSIN( AZ*RAD )
C
         GC(2,0) = DSQRT( (XX20*COSAZ)**2 + (YY20*SINAZ)**2 )
         GC(2,1) = DSQRT( (XX21*COSAZ)**2 + (YY21*SINAZ)**2 )
         GC(2,2) = DSQRT( (XX22*COSAZ)**2 + (YY22*SINAZ)**2 )
         GC(3,0) = DSQRT( (XX30*COSAZ)**2 + (YY30*SINAZ)**2 )
         GC(3,1) = DSQRT( (XX31*COSAZ)**2 + (YY31*SINAZ)**2 )
         GC(3,2) = DSQRT( (XX32*COSAZ)**2 + (YY32*SINAZ)**2 )
         GC(3,3) = DSQRT( (XX33*COSAZ)**2 + (YY33*SINAZ)**2 )
         GC(4,0) = DSQRT( (XX40*COSAZ)**2 + (YY40*SINAZ)**2 )
         GC(4,1) = DSQRT( (XX41*COSAZ)**2 + (YY41*SINAZ)**2 )
         GC(4,2) = DSQRT( (XX42*COSAZ)**2 + (YY42*SINAZ)**2 )
         GC(4,3) = DSQRT( (XX43*COSAZ)**2 + (YY43*SINAZ)**2 )
         GC(4,4) = DSQRT( (XX44*COSAZ)**2 + (YY44*SINAZ)**2 )
C
         IF( COSAZ.NE.0.D0 )
     *   PHCORR(2,0) = DATAN2( YY20*SINAZ, XX20*COSAZ ) * DEG
         PHCORR(2,1) = DATAN2( YY21*SINAZ, XX21*COSAZ ) * DEG
         PHCORR(2,2) = DATAN2( YY22*SINAZ, XX22*COSAZ ) * DEG
         IF( COSAZ.NE.0.D0 )
     *   PHCORR(3,0) = DATAN2( YY30*SINAZ, XX30*COSAZ ) * DEG
         PHCORR(3,1) = DATAN2( YY31*SINAZ, XX31*COSAZ ) * DEG
         PHCORR(3,2) = DATAN2( YY32*SINAZ, XX32*COSAZ ) * DEG
         PHCORR(3,3) = DATAN2( YY33*SINAZ, XX33*COSAZ ) * DEG
         IF( COSAZ.NE.0.D0 )
     *   PHCORR(4,0) = DATAN2( YY40*SINAZ, XX40*COSAZ ) * DEG
         PHCORR(4,1) = DATAN2( YY41*SINAZ, XX41*COSAZ ) * DEG
         PHCORR(4,2) = DATAN2( YY42*SINAZ, XX42*COSAZ ) * DEG
         PHCORR(4,3) = DATAN2( YY43*SINAZ, XX43*COSAZ ) * DEG
         PHCORR(4,4) = DATAN2( YY44*SINAZ, XX44*COSAZ ) * DEG
C
         DFACT2 = 1.D0 + K2 - H2
         DFACT3 = 1.D0 + K3 - H3
         DFACT4 = 1.D0 + K4 - H4
C
      ELSE IF( KIND.EQ.4 .OR. KIND.EQ.5 .OR. KIND.EQ.6 )  THEN
C
C        STRAIN TIDE WITH LOVE'S NUMBER H AND L
C        NANO STRAIN
         IF( KIND.EQ.5 )  AZ = 90.D0
         IF( KIND.EQ.6 )  AZ = 45.D0
         COSAZ  = DCOS(AZ*RAD)
         SINAZ  = DSIN(AZ*RAD)
         COSAZ2 = COSAZ*COSAZ
         SINAZ2 = SINAZ*SINAZ
         COSIAZ = COSAZ*SINAZ
C
         PSI   = PHI - EP
         THETA = 90.D0*RAD - PSI
         CTH   = DCOS(THETA)
         CTH2  = CTH*CTH
         STH   = DSIN(THETA)
         STH2  = STH*STH
C
         G   = CV * 1.D9/GRAV/6371023.6D2 * RR**2 / RE
         RC  = RR/RE
         RC4 = RC*RC
         GC20H =  G*0.5D0*(1.D0-3.D0*CTH2)                  * H2
         GC21H =  G*2.D0*CTH*STH                            * H2
         GC22H =  G*STH2                                    * H2
         GC30H =  G*1.11803D0*CTH*(3.D0-5.D0*CTH2)     * RC * H3
         GC31H =  G*0.72618D0*STH*(1.D0-5.D0*CTH2)     * RC * H3
         GC32H =  G*2.59808D0*CTH*STH2                 * RC * H3
         GC33H =  G*STH2*STH                           * RC * H3
         GC40H =  G*0.12500D0*(3.D0-30.D0*CTH2+35.D0*CTH2*CTH2)
     *                                                 * RC4 * H4
         GC41H =  G*0.47347D0*CTH*STH*(6.D0-14.D0*CTH2)* RC4 * H4
         GC42H =  G*0.77778D0*(1.D0-8.D0*CTH2+7.D0*CTH2*CTH2)
     *                                                 * RC4 * H4
         GC43H =  G*3.07920D0*CTH*STH2*STH             * RC4 * H4
         GC44H =  G*STH2*STH2                          * RC4 * H4
C
         GC20N =  G*3.D0*(CTH2-STH2)                        * L2
         GC21N = -G*8.D0*CTH*STH                            * L2
         GC22N =  G*2.D0*(CTH2-STH2)                        * L2
         GC30N =  G*1.11803D0*CTH*(45.D0*CTH2-33.D0)   * RC * L3
         GC31N =  G*0.72618D0*STH*(34.D0-45.D0*STH2)   * RC * L3
         GC32N =  G*2.59808D0*CTH*(9.D0*CTH2-7.D0)     * RC * L3
         GC33N =  G*STH*(6.D0-9.D0*STH2)               * RC * L3
         GC40N = -G*0.12500D0*(60.D0-540.D0*CTH2+560.D0*CTH2*CTH2)
     *                                                 * RC4 * L4
         GC41N =  G*0.47347D0*CTH*STH*(224.D0*CTH2-108.D0)
     *                                                 * RC4 * L4
         GC42N = -G*0.77778D0*(16.D0-116.D0*CTH2+112.D0*CTH2*CTH2)
     *                                                 * RC4 * L4
         GC43N =  G*3.07920D0*CTH*STH*(6.D0-16.D0*STH2)* RC4 * L4
         GC44N =  G*STH2*(12.D0-16.D0*STH2)            * RC4 * L4
C
         GC20E =  G*3.D0*CTH2                               * L2
         GC21E = -G*4.D0*CTH*STH                            * L2
         GC22E =  G*(2.D0*CTH2-4.D0)                        * L2
         GC30E =  G*1.11803D0*3.D0*(5.D0*CTH2-1.D0)    * RC * L3
         GC31E =  G*0.72618D0*STH*(14.D0-15.D0*STH2)   * RC * L3
         GC32E =  G*2.59808D0*CTH*(3.D0*CTH2-5.D0)     * RC * L3
         GC33E = -G*STH*(6.D0+3.D0*STH2)               * RC * L3
         GC40E =  G*0.12500D0*CTH2*(60.D0-140.D0*CTH2) * RC4 * L4
         GC41E =  G*0.47347D0*CTH*STH*(56.D0*CTH2-12.D0)*RC4 * L4
         GC42E = -G*0.77778D0*(4.D0-44.D0*CTH2+28.D0*CTH2*CTH2)
     *                                                 * RC4 * L4
         GC43E = -G*3.07920D0*CTH*STH*(6.D0+4.D0*STH2) * RC4 * L4
         GC44E = -G*STH2*(12.D0+4.D0*STH2)             * RC4 * L4
C
CCC      GC20X =  0.D0
         GC21X =  G*4.D0*STH                                * L2
         GC22X = -G*4.D0*CTH                                * L2
CCC      GC30X =  0.D0
         GC31X = -G*0.72618D0*20.D0*CTH*STH            * RC * L3
         GC32X =  G*2.59808D0*4.D0*(STH2-CTH2)         * RC * L3
         GC33X = -G*12.D0*CTH*STH                      * RC * L3
CCC      GC40X =  0.D0
         GC41X =  G*0.47347D0*STH*(84.D0*STH2-72.D0)   * RC4 * L4
         GC42X =  G*0.77778D0*CTH*(84.D0*CTH2-60.D0)   * RC4 * L4
         GC43X =  G*3.07920D0*STH*(18.D0*STH2-12.D0)   * RC4 * L4
         GC44X =  G*CTH*(24.D0*CTH2-24.D0)             * RC4 * L4
C
         PIN20  = ( GC20N + GC20H )*COSAZ2 + ( GC20E + GC20H )*SINAZ2
         PIN21  = ( GC21N + GC21H )*COSAZ2 + ( GC21E + GC21H )*SINAZ2
         PIN22  = ( GC22N + GC22H )*COSAZ2 + ( GC22E + GC22H )*SINAZ2
         PIN30  = ( GC30N + GC30H )*COSAZ2 + ( GC30E + GC30H )*SINAZ2
         PIN31  = ( GC31N + GC31H )*COSAZ2 + ( GC31E + GC31H )*SINAZ2
         PIN32  = ( GC32N + GC32H )*COSAZ2 + ( GC32E + GC32H )*SINAZ2
         PIN33  = ( GC33N + GC33H )*COSAZ2 + ( GC33E + GC33H )*SINAZ2
         PIN40  = ( GC40N + GC40H )*COSAZ2 + ( GC40E + GC40H )*SINAZ2
         PIN41  = ( GC41N + GC41H )*COSAZ2 + ( GC41E + GC41H )*SINAZ2
         PIN42  = ( GC42N + GC42H )*COSAZ2 + ( GC42E + GC42H )*SINAZ2
         PIN43  = ( GC43N + GC43H )*COSAZ2 + ( GC43E + GC43H )*SINAZ2
         PIN44  = ( GC44N + GC44H )*COSAZ2 + ( GC44E + GC44H )*SINAZ2
C
         POUT21 = - GC21X*COSIAZ
         POUT22 = - GC22X*COSIAZ
         POUT31 = - GC31X*COSIAZ
         POUT32 = - GC32X*COSIAZ
         POUT33 = - GC33X*COSIAZ
         POUT41 = - GC41X*COSIAZ
         POUT42 = - GC42X*COSIAZ
         POUT43 = - GC43X*COSIAZ
         POUT44 = - GC44X*COSIAZ
C
         GC(2,0) = DSQRT( PIN20*PIN20 )
         GC(2,1) = DSQRT( PIN21*PIN21 + POUT21*POUT21 )
         GC(2,2) = DSQRT( PIN22*PIN22 + POUT22*POUT22 )
         GC(3,0) = DSQRT( PIN30*PIN30 )
         GC(3,1) = DSQRT( PIN31*PIN31 + POUT31*POUT31 )
         GC(3,2) = DSQRT( PIN32*PIN32 + POUT32*POUT32 )
         GC(3,3) = DSQRT( PIN33*PIN33 + POUT33*POUT33 )
         GC(4,0) = DSQRT( PIN40*PIN40 )
         GC(4,1) = DSQRT( PIN41*PIN41 + POUT41*POUT41 )
         GC(4,2) = DSQRT( PIN42*PIN42 + POUT42*POUT42 )
         GC(4,3) = DSQRT( PIN43*PIN43 + POUT43*POUT43 )
         GC(4,4) = DSQRT( PIN44*PIN44 + POUT44*POUT44 )
C
         PHCORR(2,0) = - DATAN2( 0.0D0,  PIN20 ) * DEG
         PHCORR(2,1) = - DATAN2( POUT21, PIN21 ) * DEG
         PHCORR(2,2) = - DATAN2( POUT22, PIN22 ) * DEG
         PHCORR(3,0) = - DATAN2( 0.0D0,  PIN30 ) * DEG
         PHCORR(3,1) = - DATAN2( POUT31, PIN31 ) * DEG
         PHCORR(3,2) = - DATAN2( POUT32, PIN32 ) * DEG
         PHCORR(3,3) = - DATAN2( POUT33, PIN33 ) * DEG
         PHCORR(4,0) = - DATAN2( 0.0D0,  PIN40 ) * DEG
         PHCORR(4,1) = - DATAN2( POUT41, PIN41 ) * DEG
         PHCORR(4,2) = - DATAN2( POUT42, PIN42 ) * DEG
         PHCORR(4,3) = - DATAN2( POUT43, PIN43 ) * DEG
         PHCORR(4,4) = - DATAN2( POUT44, PIN44 ) * DEG
C
      ELSE IF( KIND.EQ.7 .OR. KIND.EQ.8 )  THEN
C
C        KIND = 7 : POTENTIAL/GRAV/RADIUS     10**(-9) STRAIN
C        KIND = 8 : POTENTIAL/GRAV            OCEAN TIDE (CM)
C
         IF( KIND.EQ.7 )  CV6 = CV*1.D9/GRAV/6371023.6D2
         IF( KIND.EQ.8 )  CV6 = CV/GRAV
C
         PSI = PHI - EP
         COSPSI = DCOS( PSI )
         SINPSI = DSIN( PSI )
          CVR2   = CV6 * RR**2 / RE
         GC(2,0) = CVR2 * ( 1.D0 - 3.D0*SINPSI**2 )/2.D0
         GC(2,1) = CVR2 * DSIN( 2.D0*PSI )
         GC(2,2) = CVR2 * COSPSI**2
          CVR3   = CVR2 * RR/RE
         GC(3,0) = DSQRT(5.D0)/2.D0 * CVR3
     *           * SINPSI * ( 3.D0 - 5.D0*SINPSI**2 )
         GC(3,1) = 3.D0*DSQRT(15.D0)/16.D0 * CVR3
     *           * COSPSI * ( 1.D0 - 5.D0*SINPSI**2 )
         GC(3,2) = 3.D0*DSQRT(3.D0)/2.D0 * CVR3
     *           * SINPSI * COSPSI**2
         GC(3,3) = CVR3 * COSPSI**3
          CVR4   = CVR3 * RR/RE
         GC(4,0) = 0.125D0 * CVR4
     *           * ( 3.D0 - 30.D0*SINPSI**2 + 35.D0*SINPSI**4 )
         GC(4,1) = 224.D0 / ( 3.D0+DSQRT(393.D0) )
     *           / DSQRT( 390.D0+2.D0*DSQRT(393.D0) ) * CVR4
     *           * DSIN( 2.D0*PSI )*( 3.D0 - 7.D0*SINPSI**2 )
         GC(4,2) = 7.D0/9.D0 * CVR4
     *           * COSPSI**2*( 1.D0 - 7.D0*SINPSI**2 )
         GC(4,3) = 16.D0/3.D0/DSQRT(3.D0) * CVR4
     *           * SINPSI*COSPSI**3
         GC(4,4) = CVR4 * COSPSI**4
C
         IF( KIND.EQ.7 )  THEN
            DFACT2 = 2.D0*H2 -  6.D0*L2
            DFACT3 = 2.D0*H3 - 12.D0*L3
            DFACT4 = 2.D0*H4 - 20.D0*L4
         ELSE IF( KIND.EQ.8 )  THEN
            DFACT2 = 1.D0 + K2 - H2
            DFACT3 = 1.D0 + K3 - H3
            DFACT4 = 1.D0 + K4 - H4
         END IF
C
      ELSE
C
         WRITE(6,200)  KIND
  200    FORMAT(//' INVALID KIND IN SETZZZ      KIND =',I5)
         STOP
C
      END IF
C
      IF( KIND.LE.3 .OR. KIND.GE.7 )  THEN
         IF( LOVENM.EQ.1 )  THEN
            GC(2,0) = GC(2,0)*DFACT2
            GC(2,1) = GC(2,1)*DFACT2
            GC(2,2) = GC(2,2)*DFACT2
            GC(3,0) = GC(3,0)*DFACT3
            GC(3,1) = GC(3,1)*DFACT3
            GC(3,2) = GC(3,2)*DFACT3
            GC(3,3) = GC(3,3)*DFACT3
            GC(4,0) = GC(4,0)*DFACT4
            GC(4,1) = GC(4,1)*DFACT4
            GC(4,2) = GC(4,2)*DFACT4
            GC(4,3) = GC(4,3)*DFACT4
            GC(4,4) = GC(4,4)*DFACT4
            WRITE(6,220)  DFACT2
            WRITE(6,230)  DFACT3
            WRITE(6,240)  DFACT4
         ELSE IF( LOVENM.EQ.2 )  THEN
            DFACTA  = DFACT3/DFACT2
            DFACTB  = DFACT4/DFACT2
            DFACTC  = DFACT4/DFACT3
            GC(3,0) = GC(3,0)*DFACTA
            GC(3,1) = GC(3,1)*DFACTA
            GC(3,2) = GC(3,2)*DFACTA
            GC(4,0) = GC(4,0)*DFACTB
            GC(4,1) = GC(4,1)*DFACTB
            GC(4,2) = GC(4,2)*DFACTB
            GC(4,3) = GC(4,3)*DFACTC
            WRITE(6,250)  DFACTA
            WRITE(6,260)  DFACTB
            WRITE(6,270)  DFACTC
         END IF
      END IF
  220 FORMAT(//' DELTA FACTOR FOR P20, P21, P22           :', F9.5 )
  230 FORMAT(  ' DELTA FACTOR FOR P30, P31, P32, P33      :', F9.5 )
  240 FORMAT(  ' DELTA FACTOR FOR P40, P41, P42, P43, P44 :', F9.5 )
  250 FORMAT(//' NORMALIZATION FACTOR FOR P30, P31, P32 :', F9.5 )
  260 FORMAT(  ' NORMALIZATION FACTOR FOR P40, P41, P42 :', F9.5 )
  270 FORMAT(  ' NORMALIZATION FACTOR FOR P43           :', F9.5 )
C
      RETURN
C
      END
      SUBROUTINE TREAD4
C
      PARAMETER ( MAXC = 1200 )
C
      REAL    DOOD, AMPL, AMPL2
      COMMON /TABLE4/ DOOD(8,MAXC), AMPL(MAXC), AMPL2(MAXC), IORD(MAXC)
C
CIBM  ACTION = 'READ'  IS NOT A STANDARD FORTRAN77
      OPEN ( 95, FILE = '/home/tamura/tide/SORTED.DAT',
     *       STATUS = 'OLD' )
CCC   OPEN ( 95, FILE = '''UBE0.TABLES.DATA(SORTED)''',
CCC  *       STATUS = 'OLD', ACTION = 'READ' )
C
      DO 10 I = 1, MAXC
   10 READ(95,100)  IORD(I), (DOOD(J,I),J=1,8), AMPL(I), AMPL2(I)
  100 FORMAT( 7X, I1, 1X, 8F3.0, 15X, 2F11.6 )
C
      CLOSE ( 95 )
C
      RETURN
      END
      DOUBLE PRECISION FUNCTION TJULID( IY, IM, ID, IH, MI )
C
C     CALCULATION OF JULIAN DATE
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      DIMENSION  DAYS(12)
C
      DATA   DAYS /   0.D0,  31.D0,  59.D0,  90.D0, 120.D0, 151.D0,
     *              181.D0, 212.D0, 243.D0, 273.D0, 304.D0, 334.D0 /
C
C
      IYY = MOD( IY, 1900 )
      IF( IYY.LE.0 .OR. IYY.GE.200 )  THEN
         WRITE(6,*)  'ERROR AT FUNCTION TJULID        IY =', IY
         STOP
      END IF
C
      TJULID =   DBLE( IYY*365 + ID + IYY/4 ) + DAYS(IM)
     *         + DBLE(IH)/24.D0 + DBLE(MI)/1440.D0 + 2415019.5D0
C
      IF( MOD(IYY,4).EQ.0 .AND. IM.LE.2 )  TJULID = TJULID - 1.D0
C
      RETURN
      END
